
const REMOVE_FROM_WHITELIST = "REMOVE_FROM_WHITELIST";
const ADD_TO_WHITELIST = "ADD_TO_WHITELIST";
const ADD_TO_TEMPLIST = "ADD_TO_TEMPLIST";
const CLEAR_TEMPLIST = "CLEAR_TEMPLIST";
const GENERATE_ID = "GENERATE_ID";
const SAVE_USER_REVIEW_FROM_API = "SAVE_USER_REVIEW_FROM_API";
const SAVE_RATING = "SAVE_RATING";
const SAVE_COMMENTS = "SAVE_COMMENTS";
const LOADING_COMMENTS = "LOADING_COMMENTS";
const SERP_SEND_LINKS_ACTION = "SERP_SEND_LINKS_ACTION";
const CLEAR_RATING = "CLEAR_RATING";
const CLEAR_COMMENTS = "CLEAR_COMMENTS";
const CLEAR_USER_REVIEWS = "CLEAR_USER_REVIEWS";
const SAVE_TABS = "SAVE_TABS";
const SET_ACTIVE_TAB = "SET_ACTIVE_TAB";
const SAVE_WITNESS = "SAVE_WITNESS";
const SAVE_RT_WITNESS = "SAVE_RT_WITNESS";
const SAVE_RETENTION_DAYS = "SAVE_RETENTION_DAYS";
const SAVE_RETENTION_COMPLETED = "SAVE_RETENTION_COMPLETED";
const SAVE_INSTALL = "SAVE_INSTALL";
const SAVE_FIRST_RUN_DATE = "SAVE_FIRST_RUN_DATE";
const TO_NEXT_STEP = "TO_NEXT_STEP";
const TO_PREVIOUS_STEP = "TO_PREVIOUS_STEP";
const OVER_NEXT_STEP = "OVER_NEXT_STEP";
const OVER_PREVIOUS_STEP = "OVER_PREVIOUS_STEP";
const RATE_SAFETY = "RATE_SAFETY";
const PRESS_SAFETY_CATEGORY = "PRESS_SAFETY_CATEGORY";
const RATE_CHILD_SAFETY = "RATE_CHILD_SAFETY";
const PRESS_CHILD_SAFETY_CATEGORY = "PRESS_CHILD_SAFETY_CATEGORY";
const PRESS_REPUTATION_CATEGORY = "PRESS_REPUTATION_CATEGORY";
const RATE_SITE = "RATE_SITE";
const EDIT_REVIEW = "EDIT_REVIEW";
const SAVE_REVIEW = "SAVE_REVIEW";
const DELETE_REVIEW = "DELETE_REVIEW";
const UPDATE_REVIEW_TIMESTAMP = "UPDATE_REVIEW_TIMESTAMP";
const DELETE_REVIEW_TIMESTAMP = "DELETE_REVIEW_TIMESTAMP";
const DELETE_REVIEW_BEFORE_REPUTATION = "DELETE_REVIEW_BEFORE_REPUTATION";
const DELETE_REVIEW_BEFORE_CHILD = "DELETE_REVIEW_BEFORE_CHILD";
const ADD_COMMENT = "ADD_COMMENT";
const ADD_COMMENT_ACTION = "ADD_COMMENT_ACTION";
const TRIPLE_NEXT_STEP = "TRIPLE_NEXT_STEP";
const TRIPLE_PREVIOUS_STEP = "TRIPLE_PREVIOUS_STEP";
const SEND_USER_REVIEW_TO_SERVER = "SEND_USER_REVIEW_TO_SERVER";
const PROTECTION_ON = "PROTECTION_ON";
const PROTECTION_OFF = "PROTECTION_OFF";
const PARENTAL_CONTROL_OFF = "PARENTAL_CONTROL_OFF";
const PARENTAL_CONTROL_ON = "PARENTAL_CONTROL_ON";
const SET_DONUTS_LEVEL = "SET_DONUTS_LEVEL";
const SET_WARNINGS_LEVEL = "SET_WARNINGS_LEVEL";
const SAVE_SERPS_CONF = "SAVE_SERPS_CONF";
const SEND_REVIEW_ACTION = "SEND_REVIEW_ACTION";
const DELETE_REVIEW_ACTION = "DELETE_REVIEW_ACTION";
const LOGIN_ACTION = "LOGIN_ACTION";
const REGISTER_ACTION = "REGISTER_ACTION";
const FORGOT_ACTION = "FORGOT_ACTION";
const GET_COMMENTS_ACTION = "GET_COMMENTS_ACTION";
const GET_COMMENT_AND_RATING = "GET_COMMENT_AND_RATING";
const GET_USER_COMMENT = 'GET_USER_COMMENT';
const LOGOUT_ACTION = "LOGOUT_ACTION";
const SAVE_USER_TOKEN = "SAVE_USER_TOKEN";
const SAVE_USER_DATA = "SAVE_USER_DATA";
const CLEAN_USER_DATA = "CLEAN_USER_DATA";
const ERROR_USER_AUTH = "ERROR_USER_AUTH";
const MESSAGE_USER_AUTH = "MESSAGE_USER_AUTH";
const EXPERIMENTAL_FEATURE = "EXPERIMENTAL_FEATURE";
const COUNT_POPUP_OPENING = "COUNT_POPUP_OPENING";
const OFF_RATE_WIDGET = "OFF_RATE_WIDGET";
const CHECK_RATE_WIDGET_DATE = "CHECK_RATE_WIDGET_DATE";
const MOBILE_TRIGGER_MODAL = "MOBILE_TRIGGER_MODAL";
const MOBILE_RATE_COUNT = "MOBILE_RATE_COUNT";
const MOBILE_TRIGGER_MODAL_RESET = "MOBILE_TRIGGER_MODAL_RESET";
const TO_NEXT_STEP_ONBOARDING = "TO_NEXT_STEP_ONBOARDING";
const UPDATE_SURVEY_STATE = "UPDATE_SURVEY_STATE";
const MAKE_SURVEY_SHOWED = "MAKE_SURVEY_SHOWED";
const UPDATE_CTA_STATUS = "UPDATE_CTA_STATUS";
const UPDATE_CTA_APPEARANCE = "UPDATE_CTA_APPEARANCE";
const SET_GDPR_NOTIFICATIONS = "SET_GDPR_NOTIFICATIONS";
const SET_GDPR_NOTIFICATIONS_OFF = "SET_GDPR_NOTIFICATIONS_OFF";
let pendingRequests = {},
    delay = IN_CASE_ERROR_INTERVAL;
//TABS
function saveTabs(tabs, activeWindow) {
	return { type: SAVE_TABS, data: { tabs: tabs, activeWindow: activeWindow } };
}
function setActiveTab(tabId) {
	return { type: SET_ACTIVE_TAB, data: { tabId } };
}
//A/B TESTING FEATURE
function saveExperimentalData(experimentalData) {
	return { type: EXPERIMENTAL_FEATURE, data: experimentalData };
}
//AUTHORIZATION
function register(name, mail, pass, Pass2) {
	return { type: REGISTER_ACTION, data: { name, mail, pass, Pass2 } };
}
function login(username, password) {
	return { type: LOGIN_ACTION, data: { username, password } };
}
function saveToken(token) {
	return { type: SAVE_USER_TOKEN, data: { token: token } };
}
function logout() {
	return { type: LOGOUT_ACTION };
}
function forgot(email) {
	return { type: FORGOT_ACTION, email: email };
}
//WHITELIST
function addToWhitelist(host) {
	if (host) {
		return { type: ADD_TO_WHITELIST, data: { host: host } };
	}
}
function removeFromWhitelist(host) {
	if (host) {
		return { type: REMOVE_FROM_WHITELIST, data: { host: host } };
	}
}
function addToTemplist(host) {
	if (host) {
		return { type: ADD_TO_TEMPLIST, data: { host: host } };
	}
}
function clearTemplist() {
	return { type: CLEAR_TEMPLIST };
}
//REQUEST RATING
function getMultipleRatings(urls) {
	return { type: SERP_SEND_LINKS_ACTION, data: { urls } };
}
function getRating(targetParams) {
	return (dispatch, getState) => {
		let url = targetParams.subtrgt;
		if (!SUPPORTED_PROTOCOLS.test(url) || checkLocalhost(url) || !getState().settings.protection || pendingRequests[url]) {
			// webextApi.browserAction.setIcon({path: ICONS.gray});
		} else {
			pendingRequests[url] = true;
			dispatch(clearComments(targetParams.host));
			WotApi.query(targetParams).then(result => {
				let uid = getState().user.uid || 1,
				    hostname = Object.keys(result.review)[0];
				delete pendingRequests[url];
				dispatch(saveRating(result.rating));
				Object.keys(result.review).length > 0 && getState().reviews[uid] && getState().reviews[uid][hostname] && result.review[hostname].step >= getState().reviews[uid][hostname].step && dispatch(saveReview(result.review));
			}, reason => {
				if (reason === API_ERROR_CODES.E101) {
					delete pendingRequests[url];
					;
				} else if (SUPPORTED_PROTOCOLS.test(url)) {
					app && app.myElement && typeof app.myElement.fire === "function" && app.myElement.fire({
						[atob("ZWE=")]: "Query",
						[atob("ZWM=")]: "Error",
						[atob("ZWw=")]: reason + '-' + url
					});
					;
				}
			});
		}
	};
}
function saveUserReviewFromApi(_ref) {
	let host = _ref.host,
	    childSafety = _ref.childSafety,
	    childSafetyCategories = _ref.childSafetyCategories,
	    comment = _ref.comment,
	    rating = _ref.rating,
	    reputationCategories = _ref.reputationCategories,
	    safetyCategories = _ref.safetyCategories,
	    step = _ref.step,
	    timestamp = _ref.timestamp,
	    uid = _ref.uid;

	const data = { host, childSafety, childSafetyCategories, comment, rating, reputationCategories, safetyCategories, step, timestamp, uid };
	return { type: SAVE_USER_REVIEW_FROM_API, data };
}
function saveRating(rating) {
	return { type: SAVE_RATING, data: rating };
}
function clearRating() {
	return { type: CLEAR_RATING };
}
function getCommentAndRating(host) {
	let uid = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

	return { type: GET_COMMENT_AND_RATING, data: { host, uid } };
}
function getComments(host) {
	let uid = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
	let length = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 20;
	let offset = arguments[3];

	return { type: GET_COMMENTS_ACTION, data: { host, length, offset, uid } };
}
function saveComments(comments) {
	return { type: SAVE_COMMENTS, data: comments };
}
function loadingComments(host) {
	return { type: LOADING_COMMENTS, data: host };
}
function clearComments() {
	let host = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

	return { type: CLEAR_COMMENTS, host: host };
}
//RATING FLOW
function toNextStep(host) {
	let userId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

	return { type: TO_NEXT_STEP, data: { host: host, userId: userId } };
}
function overNextStep(host) {
	let userId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

	return { type: OVER_NEXT_STEP, data: { host: host, userId: userId } };
}
function tripleNextStep(host) {
	let userId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

	return { type: TRIPLE_NEXT_STEP, data: { host: host, userId: userId } };
}
function triplePreviousStep(host) {
	let userId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

	return { type: TRIPLE_PREVIOUS_STEP, data: { host: host, userId: userId } };
}
function toPreviousStep(host) {
	let userId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

	return { type: TO_PREVIOUS_STEP, data: { host: host, userId: userId } };
}
function overPreviousStep(host) {
	let userId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

	return { type: OVER_PREVIOUS_STEP, data: { host: host, userId: userId } };
}
function rateSafety(host, rate) {
	let userId = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;

	return { type: RATE_SAFETY, data: { host: host, rate: rate, userId: userId } };
}
function rateChildSafety(host, rate) {
	let userId = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;

	return { type: RATE_CHILD_SAFETY, data: { host: host, rate: rate, userId: userId } };
}
function clickSafetyCategory(host, categoryId) {
	let userId = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;

	return { type: PRESS_SAFETY_CATEGORY, data: { host: host, id: categoryId, userId: userId } };
}
function clickChildSafetyCategory(host, categoryId) {
	let userId = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;

	return { type: PRESS_CHILD_SAFETY_CATEGORY, data: { host: host, id: categoryId, userId: userId } };
}
function clickOnStar(host, rating) {
	let userId = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;

	return { type: RATE_SITE, data: { host: host, rating: rating, userId: userId } };
}
function clickReputationCategory(host, categoryId) {
	let userId = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;

	return { type: PRESS_REPUTATION_CATEGORY, data: { host: host, id: categoryId, userId: userId } };
}
function saveReview(review) {
	let userId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

	return { type: SAVE_REVIEW, data: { review: review, userId: userId } };
}
function editReview(host) {
	let userId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

	return { type: EDIT_REVIEW, data: { host: host, userId: userId } };
}
function updateReviewTimestamp(host, userId) {
	return { type: UPDATE_REVIEW_TIMESTAMP, data: { host, userId } };
}
function deleteReviewTimestamp(host, userId) {
	return { type: DELETE_REVIEW_TIMESTAMP, data: { host, userId } };
}
function deleteReview(host) {
	let userId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

	return { type: DELETE_REVIEW, data: { host: host, userId: userId } };
}
function deleteReviewBeforeChild(host) {
	let userId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

	return { type: DELETE_REVIEW_BEFORE_CHILD, data: { host: host, userId: userId } };
}
function deleteReviewBeforeReputation(host) {
	let userId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

	return { type: DELETE_REVIEW_BEFORE_REPUTATION, data: { host: host, userId: userId } };
}
function sendReview(host) {
	let userId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

	return { type: SEND_REVIEW_ACTION, data: { host, userId } };
}
function deleteReviewAction(host) {
	let userId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;

	return { type: DELETE_REVIEW_ACTION, data: { host, userId } };
}
function addCommentReview(host, comment, timestamp) {
	let userId = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 1;

	return { type: ADD_COMMENT, data: { host, comment, timestamp, userId } };
}
function saveCommentAndReview(host, comment, timestamp, tags, rating) {
	let userId = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : 1;

	return { type: ADD_COMMENT_ACTION, data: { host, comment, timestamp, userId, tags, rating } };
}
//API REQUESTS
function saveWitness(witness) {
	let id = witness.id,
	    key = witness.key;

	return { type: SAVE_WITNESS, data: { id, key } };
}
function saveRtWitness(rtWitness) {
	let id = rtWitness.id,
	    key = rtWitness.key;

	return { type: SAVE_RT_WITNESS, data: { id, key } };
}
function saveRetentiontDays(sentDays) {
	return { type: SAVE_RETENTION_DAYS, data: { sentDays } };
}
function saveRetentionCompleted() {
	return { type: SAVE_RETENTION_COMPLETED };
}
function saveInstall() {
	return { type: SAVE_INSTALL };
}
function saveFirstRunDate(firstRunDate) {
	return { type: SAVE_FIRST_RUN_DATE, data: { firstRunDate } };
}
function requestSerpsConf() {
	return (dispatch, getState) => {
		WotApi.getSerps().then(conf => {
			dispatch(saveSerpsConf(conf));
			delay = IN_CASE_ERROR_INTERVAL;
			setTimeout(() => {
				dispatch(requestSerpsConf());
			}, SERPS_REQUEST_INTERVAL);
		}, reason => {
			;
			delay = delay * 2;
			setTimeout(() => {
				dispatch(requestSerpsConf());
			}, delay);
		});
	};
}
function saveSerpsConf(conf) {
	return { type: SAVE_SERPS_CONF, data: conf };
}
//CHANGE SETTINGS
function redirectInsteadPopup() {
	webextApi.tabs.query({ active: true, currentWindow: true }, tabs => {
		let tab = tabs[0],
		    tabUrl = tab.url,
		    host = WotApi.getEncodedDomain(tabUrl);
		webextApi.tabs.create({ url: FULL_REPORT_URL + host + MAIN_BUTTON_RTP_OFF_PARAMETERS });
	});
}
function turnOnProtection() {
	webextApi.browserAction.setPopup({ popup: "popup.html" });
	return { type: PROTECTION_ON };
}
function turnOffProtection() {
	webextApi.browserAction.setPopup({ popup: "" });
	return { type: PROTECTION_OFF };
}
function turnOnParentalControl() {
	return { type: PARENTAL_CONTROL_ON };
}
function turnOffParentalControl() {
	return { type: PARENTAL_CONTROL_OFF };
}
function setDonutsLevel(level) {
	let id = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'all';

	return { type: SET_DONUTS_LEVEL, data: { level: level, id: id } };
}
function setWarningsLevel(level) {
	return { type: SET_WARNINGS_LEVEL, data: { level: level } };
}
// RATE US WIDGET
function countPopupOpening() {
	return { type: COUNT_POPUP_OPENING };
}
function offRateWidget() {
	return { type: OFF_RATE_WIDGET };
}
function checkRateWidgetDate() {
	return { type: CHECK_RATE_WIDGET_DATE };
}
function mobileTrigerModal() {
	return { type: MOBILE_TRIGGER_MODAL };
}
function mobileRateCount() {
	return { type: MOBILE_RATE_COUNT };
}
function mobileTrigerModalReset() {
	return { type: MOBILE_TRIGGER_MODAL_RESET };
}
function toNextStepOnboarding() {
	let step = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

	return { type: TO_NEXT_STEP_ONBOARDING, data: { step: step } };
}
function updateCtaStatus(status) {
	return { type: UPDATE_CTA_STATUS, data: status };
}
function updateCtaAppearance() {
	return { type: UPDATE_CTA_APPEARANCE };
}
function updateSurveyState(newSurveyState) {
	return { type: UPDATE_SURVEY_STATE, data: { newSurveyState } };
}
function makeSurveyShowed() {
	return { type: MAKE_SURVEY_SHOWED };
}
function setGDPRNotifications() {
	return { type: SET_GDPR_NOTIFICATIONS };
}
function setGDPRNotificationsOff() {
	return { type: SET_GDPR_NOTIFICATIONS_OFF };
}