
class SharingHandler {
  constructor() {}
  init() {
    if (window.location.href.indexOf(FACEBOOK_DIALOG_URL) !== -1) {
      let textArea = document.getElementsByClassName('mentionsTextarea').length > 0 && document.getElementsByClassName('mentionsTextarea')[0],
          match = window.location.href.match('[?&]description=([^&]+)'),
          text = decodeURIComponent(match && match.length >= 2 ? match[1] : '');
      if (textArea && text) {
        let evt = document.createEvent("KeyboardEvent"),
            initMethod = typeof evt.initKeyboardEvent !== 'undefined' ? "initKeyboardEvent" : "initKeyEvent";
        evt[initMethod]('keyup', // event type : keydown, keyup, keypress
        true, // bubbles
        true, // cancelable
        window, // viewArg: should be window
        false, // ctrlKeyArg
        false, // altKeyArg
        false, // shiftKeyArg
        false, // metaKeyArg
        32, // keyCodeArg : unsigned long the virtual key code, else 0
        0 // charCodeArgs : unsigned long the Unicode character associated with the depressed key, else 0
        );
        setTimeout(() => {
          textArea.value = text;
          textArea.style.height = '65px';
          let _evt = document.createEvent('HTMLEvents');
          _evt.initEvent('focus', true, true);
          textArea.dispatchEvent(_evt);
          _evt.initEvent('change', true, true);
          textArea.dispatchEvent(_evt);
          _evt.initEvent('input', true, true);
          textArea.dispatchEvent(_evt);
          textArea.dispatchEvent(evt);
        }, 1000);
      } else {
        setTimeout(this.init.bind(this), 500);
      }
    }
  }
}