
class ModalRatingOld extends React.Component {
    redirectToExtensionPage() {
        let url;
        switch (browserName) {
            case 'firefox':
                url = FIREFOX_WEBSTORE_URL;
                break;
            case 'chrome':
                url = CHROME_WEBSTORE_URL;
                break;
            default:
                url = CHROME_WEBSTORE_URL;
                break;
        }
        webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url });
        this.props.dispatch(offRateWidget());
        window.close();
    }
    render() {
        return React.createElement(
            'div',
            { className: 'wot-rate-us-old' },
            React.createElement(
                'div',
                { className: 'rate-us__header' },
                React.createElement('span', { className: 'rate-us__image' })
            ),
            React.createElement(
                'div',
                { className: 'wot-rate-us-old-text' },
                React.createElement(
                    'div',
                    { className: 'modal-message__header modal-message__header_rate-header' },
                    webextApi.i18n.getMessage('wantToRateWOTHeader')
                ),
                React.createElement(
                    'div',
                    { className: 'modal-message__header modal-message__header_rate-text' },
                    webextApi.i18n.getMessage('wantToRateWOT').replace('%BROWSER%', upperFirstCase(browserName))
                )
            ),
            React.createElement(
                'div',
                { className: 'modal-message__button-container__item modal-message__button-container__item_rate', onClick: this.redirectToExtensionPage.bind(this) },
                React.createElement('i', { className: 'rate-us__button-icon' }),
                webextApi.i18n.getMessage('wantToRateWOTBtn')
            ),
            React.createElement(
                'div',
                { className: 'modal-message__button-container__item modal-message__button-container__item_no-thanks', onClick: this.props.onClose },
                webextApi.i18n.getMessage('noThanks')
            )
        );
    }
}