
class ModalRatingSharing extends React.Component {
    goToFacebookPage() {
        webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url: getFacebookSharingUrl(this.props.host, this.props.reviews.rating) });
        webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Rating Flow",
                [atob("ZWE=")]: "Share Facebook",
                [atob("ZWw=")]: ""
            }
        });
        window.close();
    }
    goToTwitterPage() {
        webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url: getTwitterSharingUrl(this.props.host, this.props.reviews.rating) });
        webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Rating Flow",
                [atob("ZWE=")]: "Share Twitter",
                [atob("ZWw=")]: ""
            }
        });
        window.close();
    }
    goToGooglePage() {
        webextApi.runtime.sendMessage({ name: OPEN_TAB_MESSAGE, url: getGoogleSharingUrl(this.props.host, this.props.reviews.rating) });
        webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Rating Flow",
                [atob("ZWE=")]: "Share Google+",
                [atob("ZWw=")]: ""
            }
        });
        window.close();
    }
    onClose() {
        webextApi.runtime.sendMessage({
            name: SEND_MESSAGE, params: {
                [atob("ZWM=")]: "Rating Flow",
                [atob("ZWE=")]: "Share Close",
                [atob("ZWw=")]: ""
            }
        });
        this.props.onClose();
    }
    /**/
    render() {
        return React.createElement(
            "div",
            { className: "rating-sharing" },
            React.createElement("span", { className: "rating-sharing__img" }),
            React.createElement(
                "div",
                { className: "rating-sharing__text" },
                React.createElement(
                    "span",
                    { className: "rating-sharing__text-item" },
                    webextApi.i18n.getMessage('youRatingThisSite')
                ),
                React.createElement(
                    "span",
                    { className: "rating-sharing__text-item" },
                    webextApi.i18n.getMessage('shareYouRating')
                )
            ),
            React.createElement(
                "div",
                { className: "rating-sharing__buttons" },
                React.createElement(
                    "div",
                    { className: "rating-sharing__facebook",
                        onClick: this.goToFacebookPage.bind(this) },
                    React.createElement("span", { className: "rating-sharing__facebook_icon" }),
                    webextApi.i18n.getMessage('shareOnFacebook')
                ),
                React.createElement(
                    "div",
                    { className: "rating-sharing__twitter",
                        onClick: this.goToTwitterPage.bind(this) },
                    React.createElement("span", { className: "rating-sharing__twitter_icon" }),
                    webextApi.i18n.getMessage('shareOnTwitter')
                ),
                React.createElement(
                    "div",
                    { className: "rating-sharing__google",
                        onClick: this.goToGooglePage.bind(this) },
                    React.createElement("span", { className: "rating-sharing__google_icon" }),
                    webextApi.i18n.getMessage('shareOnGoogle')
                )
            ),
            React.createElement(
                "div",
                { className: "modal-message__button-container__item modal-message__button-container__item_no-thanks", onClick: this.onClose.bind(this) },
                webextApi.i18n.getMessage('noThanks')
            )
        );
    }
}