
class WarningMessageContainer extends React.Component {
    render() {
        var _props = this.props;
        let parent = _props.parent,
            type = _props.type;

        return React.createElement(
            "div",
            { className: "main-warning__message" },
            React.createElement("div", { className: parent ? "main-warning__message-container__img main-warning__message-container__img_block" : "main-warning__message-container__img  main-warning__message-container__img_warning" }),
            React.createElement(
                "div",
                { className: "main-warning__message-container__title" },
                webextApi.i18n.getMessage(parent ? 'blocked' : type.indexOf('+caution') != -1 ? 'careful' : 'warning')
            ),
            React.createElement(
                "div",
                { className: "main-warning__message-container__text" },
                webextApi.i18n.getMessage(parent ? 'adultContent' : type.indexOf('+caution') != -1 ? 'badReviewWarningText' : 'potentiallyMalicious')
            )
        );
    }
}