
class LoadingError extends React.Component {
  constructor(props) {
    super(props);
    this.retryRequest = this.retryRequest.bind(this);
  }
  retryRequest() {
    webextApi.runtime.sendMessage({ name: RETRY_QUERY_DATA });
    location.reload();
  }
  render() {
    return React.createElement(
      "div",
      { className: "error-page" },
      React.createElement("div", { className: "error-page__image" }),
      React.createElement(
        "span",
        { className: "error-page__text1" },
        webextApi.i18n.getMessage('loadingErrorText1')
      ),
      React.createElement(
        "span",
        { className: "error-page__text2" },
        webextApi.i18n.getMessage('loadingErrorText2')
      ),
      React.createElement(
        "div",
        { className: "error-page__retry-btn", onClick: this.retryRequest },
        React.createElement("div", { className: "retry-icon" }),
        React.createElement(
          "span",
          { className: "retry-text" },
          webextApi.i18n.getMessage('loadingErrorRetryText')
        )
      )
    );
  }
}