
//COMPONENTS
class RatingFlowRatePage extends React.Component {
    render() {
        var _props = this.props;
        const rating = _props.rating,
              host = _props.host,
              dispatch = _props.dispatch,
              step = _props.step,
              userId = _props.userId;

        return React.createElement(
            "div",
            { className: "rating-flow rating-flow_right rating-flow_second" },
            React.createElement(
                "div",
                { className: "rating-flow_rate-page" },
                React.createElement(
                    "div",
                    { className: "rating-flow_safe__header" },
                    React.createElement(FormattedString, { text: webextApi.i18n.getMessage('rateOverall').replace('%DOMAIN%', truncateString(WotApi.getDecodedDomain(host), 22, 16)) })
                ),
                React.createElement(RatingStarsContainer, { dispatch: dispatch, host: host, rating: rating, userId: userId })
            ),
            React.createElement(RatingFlowFooter, { rating: rating,
                typeNextButton: rating === -1 ? "disable" : "active",
                dispatch: dispatch, step: step,
                host: host,
                nextAction: rating <= 60 ? toNextStep : overNextStep,
                userId: userId })
        );
    }
}